DECLARE SUB ScrollMenu ()
'
'
'you will have to modify, 'MenuName$ = "Buster", when you save your own set
'of menu's.
'
'use this program after you use POP001.BAS to make a set of menu's
'
'the first time you use these programs, RUN THIS ONE FIRST.  not as a caution,
'but just to give you an idea of what this program does.  scroll through each
'menu with the up/down arrow keys.  ESC erases a menu and lets you see
'another one.
'
'the process is simple.  run POP001.BAS.  intiallly there will be a box
'in the middle of the screen.  size the box and move it to where you want it.
'press the F1 key to insert text into the box.  cursor all the way past the
'last line of the box, all the while entering the text you want in it.  you
'must enter at least a space on each line.  after the last carriage return, a
'beep will sound and a prompt on the last line of the screen asking you what
'name you'd like to give to the system of menus.
'enter a name of your choice.  after you do that, the process starts over
'with another tiny box in the middle of the screen.  move it and size it and
'enter text.  when you cursor past the last line of the sized box it will
'automatically be saved under the name that you gave to the first box.  that
'name is the name of your system of menus.  there's not much room for errors.
'if you down size the orginal box the program will not permit anymore
'resizing.  there are two .BAS programs... POP001.BAS and BUILTMNU.BAS
'you are free to make any modifications that you like.
'it should be you intention to add this routine to your .BAS program that
'you want to add a system of scrolling menus to.  the program will need
'modification in a relatively simple way.  the idea is to call 'ScrollMenu'
'on a keystroke that you use to open a menu in your program.  you can make
'modifications at the 'MODIFY HERE' remark to take the action you desire
'when the choice is made in the menu.  I made up a few meaningless menus
'that you can see if you run this Basic program.  press shift+F5.  ESC erases
'each menu.  use the up/ down arrow keys.  there are 7 menus's.
'
'if you like you can use pop001 to write a set of menu's.
'the you can modify the 'ScrollMenu SUB to accept which ever menu you choose.
'you will have to take note of how many menu's you built and act accordingly.

        DO
           CLS
           INPUT "Enter MenuNumber%, (1 thru 7).  '0' ends ", DesiredMenu%
           IF DesiredMenu% = 0 THEN
              END
           END IF
           
           CALL ScrollMenu
        LOOP

SUB ScrollMenu

SHARED DesiredMenu%

        'where cursor is when menu is called
        HoldCSRLIN% = CSRLIN
        HoldPOS% = POS(0)

        'turn off cursor for menu
        LOCATE , , 0

        'this number is determined by the key combination that calls this
        'SUB.  for example, if you set up a keystroke to call an EDIT menu
        'this number will correspond to the menu number you built using
        'POP001.BAS.  POP001.BAS can be made .exe
        'in my program I just set up one menu, MenuNumber%=1
        MenuNumber% = DesiredMenu%

        'this is what you saved the group as when asked in POP001.BAS
        MenuName$ = "Buster"

        'begins loading menu data '''''''''''''''''''''''''''''''
        OPEN MenuName$ + ".NUM" FOR INPUT AS #1                 '
             INPUT #1, NumberOfMenus%                           '
        CLOSE #1                                                '
                                                                '
        REDIM GetMenuData$(1 TO NumberOfMenus% * 26)            '
                                                                '
        OPEN MenuName$ + ".MNU" FOR INPUT AS #1                 '
             DO UNTIL EOF(1)                                    '
             LineValue% = LineValue% + 1                        '
             INPUT #1, GetMenuData$(LineValue%)                 '
             LOOP                                               '
        CLOSE #1                                                '
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''

                'certain characteristics, such as position of menu
                Height% = VAL(GetMenuData$((MenuNumber% - 1) * 26 + 3))
                BoxWidth% = LEN(GetMenuData$((MenuNumber% - 1) * 26 + 3 + 1))
                UpperRow% = VAL(GetMenuData$((MenuNumber% - 1) * 26 + 1))
                LeftCol% = VAL(GetMenuData$((MenuNumber% - 1) * 26 + 2))

                'save what should be under menu
                REDIM UnderMenu$(0 TO VAL(GetMenuData$((MenuNumber% - 1) * 26 + 3)))
                FOR SaveBoxY% = 1 TO Height%
                    FOR SaveBoxX% = 1 TO BoxWidth%
                        LOCATE UpperRow% + SaveBoxY% - 1, LeftCol% + SaveBoxX% - 1
                        UnderMenu$(SaveBoxY%) = UnderMenu$(SaveBoxY%) + CHR$(SCREEN(UpperRow% - 1 + SaveBoxY%, LeftCol% + SaveBoxX% - 1))
                    NEXT
                NEXT

                'display the menu
                COLOR 0, 7
                LOCATE VAL(GetMenuData$((MenuNumber% - 1) * 26 + 1)), VAL(GetMenuData$((MenuNumber% - 1) * 26 + 2))
                FOR DisplayMenu% = 1 TO VAL(GetMenuData$((MenuNumber% - 1) * 26 + 3)) - 1
                    PRINT GetMenuData$((MenuNumber% - 1) * 26 + 3 + DisplayMenu%)
                    LOCATE CSRLIN, VAL(GetMenuData$((MenuNumber% - 1) * 26 + 2))
                NEXT
                LOCATE CSRLIN, VAL(GetMenuData$((MenuNumber% - 1) * 26 + 2))
                PRINT GetMenuData$((MenuNumber% - 1) * 26 + 3 + VAL(GetMenuData$((MenuNumber% - 1) * 26 + 3)));
                'end menu display routine

                COLOR 0, 1

                'initialize scroll number.  this is the 'choice' in the menu
                Display% = 0

                'if the down arrow key is not pressed first, scroll to
                'the bottom of menu
                KeyNotDown% = -1

                'general routine for scrolling through menu
        DO
                DO
                   GetKey$ = INKEY$

                   'exit menu on ESC.''''''''''''''''''''''''''''''''''''
                   IF RIGHT$(GetKey$, 1) = CHR$(27) THEN                '
                        COLOR 0, 1                                      '
                        FOR SaveBoxY% = 1 TO Height%                    '
                            LOCATE UpperRow% + SaveBoxY% - 1, LeftCol%  '
                            PRINT UnderMenu$(SaveBoxY%)                 '
                        NEXT                                            '
                        LOCATE , , 1                                    '
                      LOCATE HoldCSRLIN%, HoldPOS%                      '
                      EXIT SUB                                          '
                   ''''''''''''''''''''''''''''''''''''''''''''''''''''''
                      ELSEIF RIGHT$(GetKey$, 1) = CHR$(80) THEN
                      EnteredLoop% = -1

FlyBall:
                           KeyNotDown% = 0
                           IF Display% < Height% - 2 THEN
                             LOCATE UpperRow% + Display% + 1, LeftCol% + 1
                             COLOR 0, 1
                             PRINT MID$(GetMenuData$((MenuNumber% - 1) * 26 + 4 + (Display% + 1)), 2, LEN(GetMenuData$((MenuNumber% - 1) * 26 + 4 + (Display% + 1))) - 2);
                           END IF
                           IF Display% > 0 AND Display% < Height% - 2 THEN
                             LOCATE UpperRow% + Display%, LeftCol% + 1
                             COLOR 0, 7
                             PRINT MID$(GetMenuData$((MenuNumber% - 1) * 26 + 4 + (Display% + 1) - 1), 2, LEN(GetMenuData$((MenuNumber% - 1) * 26 + 4 + (Display% + 1) - 1)) - 2);
                           END IF
                           IF Display% = Height% - 2 THEN
                              LOCATE UpperRow% + Display%, LeftCol% + 1
                              COLOR 0, 7
                              PRINT MID$(GetMenuData$((MenuNumber% - 1) * 26 + 4 + (Display% + 1) - 1), 2, LEN(GetMenuData$((MenuNumber% - 1) * 26 + 4 + (Display% + 1) - 1)) - 2);
                              Display% = 0
                              GOTO FlyBall
                           END IF

                           IF Display% < Height% - 2 THEN
                              Display% = Display% + 1
                           END IF

                      ELSEIF RIGHT$(GetKey$, 1) = CHR$(72) THEN
                      EnteredLoop% = -1

                        IF KeyNotDown% THEN
                           KeyNotDown% = 0
                           Display% = Height% - 1
                        END IF

GroundedOut:
                           IF Display% > 1 THEN
                             LOCATE UpperRow% + Display% - 1, LeftCol% + 1
                             COLOR 0, 1
                             PRINT MID$(GetMenuData$((MenuNumber% - 1) * 26 + 4 + (Display% - 1)), 2, LEN(GetMenuData$((MenuNumber% - 1) * 26 + 4 + (Display% - 1))) - 2);
                           END IF

                           IF Display% > 1 THEN
                             LOCATE UpperRow% + Display%, LeftCol% + 1
                             COLOR 0, 7
                             PRINT MID$(GetMenuData$((MenuNumber% - 1) * 26 + 4 + (Display% - 1) + 1), 2, LEN(GetMenuData$((MenuNumber% - 1) * 26 + 4 + (Display% - 1) + 1)) - 2);
                           END IF

                           IF Display% = 1 THEN
                              LOCATE UpperRow% + Display%, LeftCol% + 1
                              COLOR 0, 7
                              PRINT MID$(GetMenuData$((MenuNumber% - 1) * 26 + 4 + (Display% + 1) - 1), 2, LEN(GetMenuData$((MenuNumber% - 1) * 26 + 4 + (Display% + 1) - 1)) - 2);
                              Display% = Height% - 1
                              GOTO GroundedOut
                           END IF

                           IF Display% > 1 THEN
                              Display% = Display% - 1
                           END IF
                'end routine for scrolling through menu with the arrow keys

                'execute the selected scroll position
                      ELSEIF RIGHT$(GetKey$, 1) = CHR$(13) AND EnteredLoop% THEN

'MODIFY HERE
                           SELECT CASE Display%

                           ''''''this will erase the menu and restore original
                           '     text.  this loop should exist for each
                           '     carriage return implying the menu should
                           '     be erased
                           '       CASE IS = 1
                           '       COLOR 0, 1
                           '       FOR SaveBoxY% = 1 TO Height%
                           '           LOCATE UpperRow% + SaveBoxY% - 1, LeftCol%
                           '           PRINT UnderMenu$(SaveBoxY%)
                           '       NEXT
                           ''''''''''''''''''''''''''''''''''''''''''''''''''
                           '       an example for one of my files
                           '       LOCATE , , 1
                           '       CALL LoadFile
                           '       LOCATE HoldCSRLIN%, HoldPOS%
                           '       EXIT SUB
                           '
                           '       'a certain item from the menu
                           '       CASE IS = 2
                           '
                           ''''''''restoring screen to original text
                           '       COLOR 0, 1
                           '       FOR SaveBoxY% = 1 TO Height%
                           '           LOCATE UpperRow% + SaveBoxY% - 1, LeftCol%
                           '           PRINT UnderMenu$(SaveBoxY%)
                           '       NEXT
                           ''''''''''''''''''''''''''''''''''''''''''''''''''
                           '       another example SUB to execute
                           '       LOCATE , , 1
                           '       CALL SaveFile
                           '       LOCATE HoldCSRLIN%, HoldPOS%
                           '       EXIT SUB
                           '
                           '       an item from the menu.  each item begins
                           '       with CASE=ItemNumber_in_menu
                           '       CASE IS = 3
                           '
                           ''''''''suppress execution for a certain reason.
                           '       In the program I originally used this,
                           '       it suppressed finding a string if no
                           '       text at all had been typed.
                           '       NotBegun% = CurrentRow% = 1 AND LEN(EditorLine$(1)) = 0
                           '       IF NOT NotBegun% THEN
                           ''''''''''''''''''''''''''''''''''''''''''''''''''
                           ''''''''restore original text on entering SUB
                           '       execution.
                           '       COLOR 0, 1
                           '       FOR SaveBoxY% = 1 TO Height%
                           '           LOCATE UpperRow% + SaveBoxY% - 1, LeftCol%
                           '           PRINT UnderMenu$(SaveBoxY%)
                           '       NEXT
                           ''''''''''''''''''''''''''''''''''''''''''''''''''
                           '       execute SUB for a certain reason
                           '       LOCATE , , 1
                           '       CALL FindString
                           '       LOCATE FromSrchRow%, FromSrchCol%
                           '       EXIT SUB
                           '       END IF
                           '       CASE IS = 4
                           '
                           '       suppressed execution for a certain reason.
                           '       In my program it suppressed typing a file
                           '       if no text had been entered at all.
                           '       NotBegun% = CurrentRow% = 1 AND LEN(EditorLine$(1)) = 0
                           '       IF NOT NotBegun% THEN
                           '
                           ''''''''restore original text when erasing menu.
                           '       COLOR 0, 1
                           '       FOR SaveBoxY% = 1 TO Height%
                           '           LOCATE UpperRow% + SaveBoxY% - 1, LeftCol%
                           '           PRINT UnderMenu$(SaveBoxY%)
                           '       NEXT
                           ''''''''''''''''''''''''''''''''''''''''''''''''''
                           '       LOCATE , , 1
                           '       CALL PrintDocument
                           '
                           '       in my program, the cursor position will
                           '       be renewed
                           '       LOCATE HoldCSRLIN%, HoldPOS%
                           '       EXIT SUB
                           '       END IF
                           '       CASE IS = 5
                           '
                           ''''''''erase menu and restore original text
                           '       COLOR 0, 1
                           '       FOR SaveBoxY% = 1 TO Height%
                           '           LOCATE UpperRow% + SaveBoxY% - 1, LeftCol%
                           '           PRINT UnderMenu$(SaveBoxY%)
                           '       NEXT
                           ''''''''''''''''''''''''''''''''''''''''''''''''''
                           '       LOCATE , , 1
                           '       COLOR 0, 1
                           '       CLS
                           '       in my program, EXIT was executed.
                           '       END
                           END SELECT

                         EXIT DO
                   END IF
                LOOP WHILE GetKey$ = ""
        LOOP

END SUB

